extends Area2D

@export var speed = 400
@export var shot_scene: PackedScene
var finalShot = 0.0

signal shot_signal

# Called when the node enters the scene tree for the first time.
func _ready():
	pass


# Called every frame. 'delta' is the elapsed time since the previous frame.
func _process(delta):
	var velocity = Vector2.ZERO # The player's movement vector.
	var rate = 1
	if Input.is_action_pressed("move_right"):
		velocity.x += 1
	if Input.is_action_pressed("move_left"):
		velocity.x -= 1
	if Input.is_action_pressed("move_down"):
		velocity.y += 1
	if Input.is_action_pressed("move_up"):
		velocity.y -= 1
	if Input.is_action_pressed("slow"):
		rate = 0.5
	if Input.is_action_pressed(("shot")) and finalShot > 0.1:
		var shot = shot_scene.instantiate()
		shot.linear_velocity = Vector2(0,-800)
		shot.position = position
		# ステージに生成を指示
		shot_signal.emit(shot)
		finalShot = 0

	finalShot += delta

	if velocity.length() > 0:
		velocity = velocity.normalized() * speed * rate
		$AnimatedSprite2D.play()
	else:
		$AnimatedSprite2D.stop()
		
	position += velocity * delta
	position = position.clamp(Vector2(15,15), Vector2(960-15,1080-15))

	if velocity.x != 0:
		$AnimatedSprite2D.animation = "walk"
		$AnimatedSprite2D.flip_h = velocity.x < 0
	elif velocity.y != 0:
		$AnimatedSprite2D.animation = "up"
